variables:
  REPO: "https://gitlab.com/yurii.andriuk/kbot"
  BRANCH: "main"
  REGISTRY: "registry.gitlab.com/yurii.andriuk"
  APP: "kbot"
  GHCR: "https://registry.gitlab.com"
  USER_NAME: yurii.andriuk
  GIT_STRATEGY: clone
  GIT_DEPTH: 0

  OS: 
    value: "linux"
    options:
      - "linux"
      - "windows"
      - "darwin"
    description: "Target operation system for build and docker imagecreation"
  
  ARCH: 
    value: "amd64"
    options:
      - "amd64"
      - "arm64"
      - "i386"
    description: "Target architecture for build and docker imagecreation"

stages:
  - clone
  - test
  - build
  - create_image
  - push

clone:
  stage: clone
  tags:
    - local
  script:
    - echo 'Starting the cloning process...'
    - |
      if [ ! -d "$CI_PROJECT_DIR/$APP" ]; then
        echo "Cloning the '$BRANCH' branch of the repository..."
        git clone -b "$BRANCH" --depth 1 "$REPO" "$CI_PROJECT_DIR/$APP"
        echo "Repository successfully cloned into $CI_PROJECT_DIR/$APP"
      else
        echo "Directory $CI_PROJECT_DIR/$APP already exists. Skipping clone."
      fi

cache:
  paths:
  - kbot/
  
test:
  stage: test
  tags:
    - local
  script:
    - echo 'TEST STARTED'
    - cd $APP
    - make test
  dependencies:
    - clone

build:
  stage: build
  tags:
    - local
  dependencies:
    - test
  script:
    - echo 'BUILD STARTED'
    - cd $APP
    - make build TARGETOS=$OS TARGETARCH=$ARCH

create_image:
  stage: create_image
  tags:
    - local
  dependencies:
    - build
  script:
    - VERSION=$(git describe --tags --abbrev=0)-$(git rev-parse --short HEAD)
    - echo "Version is set to ${VERSION}"
    - echo 'IMAGE STARTED'
    - cd $APP
    - export REGISTRY="registry.gitlab.com/yurii.andriuk"
    - make image REGISTRY=$REGISTRY APP=$APP VERSION=$VERSION TARGETOS=$OS TARGETARCH=$ARCH

push:
  stage: push
  tags:
    - local
  dependencies:
    - create_image
  before_script:
    - docker login -u $USER_NAME -p $GITLAB_TOKEN ${GHCR}
  script:
    - echo 'PUSH TO GHCR'
    - echo $REGISTRY
    - VERSION=$(git describe --tags --abbrev=0)-$(git rev-parse --short HEAD) 
    - export REGISTRY="registry.gitlab.com/yurii.andriuk"
    - cd $APP
    - make push REGISTRY=$REGISTRY APP=$APP VERSION=$VERSION TARGETOS=$OS TARGETARCH=$ARCH
